import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Cube here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Cube extends Actor
{
    public static final Color ALPHA = new Color(0, 0, 0, 0);
    private int z = 1;
    private GreenfootImage img;
    private Color color;
    private int x;
    private int xel = 1;
    private int y;
    private int length;
    private int speed;
    private int xSpeed;
    private int zMax = 100;
    private A3DWorld wd;
    public Cube(int length, int speed, Color color, int x, int y)
    {
        this.x = x;
        this.y = y;
        this.length = length;
        this.speed = speed;
        if (Greenfoot.getRandomNumber(2) <1) xSpeed = speed;
        else xSpeed = -speed;
        this.color = color;
        img = new GreenfootImage(A3DWorld.WIDTH, A3DWorld.HEIGHT);
    }

    /**
     * Act - do whatever the Cube wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        if (z < 10000)
        {
            drawCube(length,x,y,z,0);
            z += speed;
            // x += xSpeed;
            // xSpeed += xel;
            // if (speed > 10)
            // {
                // xel = -1;
            // }
            // if (speed < -10)
            // {
                // xel = 1;
            // }
        }
        else
        {
            getWorld().removeObject(this);
        }
    }

    private void draw3dLine(double x1, double y1, double z1, double x2, double y2, double z2)
    {
        img.setColor(color);
        img.drawLine(A3DWorld.WIDTH / 2 + (int) (x1 / (A3DWorld.VIEW_CONST*z1)), A3DWorld.HEIGHT / 2 + (int) (y1 / (A3DWorld.VIEW_CONST*z1)), A3DWorld.WIDTH / 2 + (int) (x2 / (A3DWorld.VIEW_CONST*z2)), A3DWorld.HEIGHT / 2 + (int) (y2 / (A3DWorld.VIEW_CONST*z2)));
        setImage(img);
    }
    
    private void draw3dSquare(double x, double y, double z, double length)
    {
        img.setColor(color);
        img.drawRect(A3DWorld.WIDTH / 2 + (int) (x / (A3DWorld.VIEW_CONST*z)), A3DWorld.HEIGHT / 2 + (int) (y / (A3DWorld.VIEW_CONST*z)), (int) (length / (A3DWorld.VIEW_CONST*z)), (int) (length / (A3DWorld.VIEW_CONST*z)));
    }

    private void drawCube(int length, int x, int y, int z, int a)
    {
        // img.setColor(ALPHA);
        // img.fill();
        img.clear();
        if (z > 0)
        {
            draw3dSquare(x, y, z + length, length);
            draw3dLine(x, y, z, x, y, z + length);
            draw3dLine(x + length, y, z, x + length, y, z + length);
            draw3dLine(x + length, y + length, z, x + length, y + length, z + length);
            draw3dLine(x, y + length, z, x, y + length, z + length);
            draw3dSquare(x, y, z, length);
            zMax = (int) (length / (double) (A3DWorld.VIEW_CONST * z));
        }
    }
}
